<?php
/**
 * @package    HikaShop Vendor Zip Filter
 * @version    1.0.0
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2012-2013 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikaShopQuickbooksexport extends JPlugin {

	/**
	 *
	 */
	function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	/**
	 *
	 */
	function onBeforeOrderExport(&$rows, &$obj) {
		// Load options
		//
		$activated = false;
		$pluginsClass = hikashop_get('class.plugins');
		$plugin = $pluginsClass->getByName('hikashop','quickbooksexport');
		if(!empty($plugin) ) {
			if(!empty($plugin->params['opt_activated'])) { 
				$activated = ($plugin->params['opt_activated'] == '1');
			}
		}
		if(!$activated)
			return;
		
		// Do export
		//
		$this->exportOrders($rows, $obj);
	}

	/**
	 *
	 */
	function onOrderExportList(&$exports) {
		$exports[] = 'quickbooksexport';
	}

	/**
	 *
	 */
	function exportOrders(&$rows, &$obj) {
		$fields = array(
			'order_id',
			'order_status',
			'order_discount_code',
			'order_shipping_price',
			'order_discount_price',
			'order_payment_method',
			'order_shipping_method',
			'order_full_price',
			'order_shipping_tax',
			'order_discount_tax',
			'order_number',
			'name',
			'email',
			'shipping_address_title',
			'shipping_address_firstname',
			'shipping_address_lastname',
			'shipping_address_company',
			'shipping_address_street',
			'shipping_address_post_code',
			'shipping_address_city',
			'shipping_address_telephone',
			'shipping_address_state',
			'shipping_address_country',
			'shipping_address_vat',
			'billing_address_title',
			'billing_address_firstname',
			'billing_address_lastname',
			'billing_address_company',
			'billing_address_street',
			'billing_address_post_code',
			'billing_address_city',
			'billing_address_telephone',
			'billing_address_state',
			'billing_address_country',
			'billing_address_vat',
			'order_full_tax',
			'item_order_product_quantity',
			'item_order_product_name',
			'item_order_product_code',
			'item_order_product_price',
			'item_order_product_tax'
		//	'item_order_product_options'
		);
		$stripFields = array(
			'item_order_product_name'
		);

		$db = JFactory::getDBO();
		$db->setQuery('SELECT shipping_id, shipping_type, shipping_name FROM '.hikashop_table('shipping'));
		$shippings = $db->loadObjectList();

		$newRows = array();
		foreach($rows as $k => $order) {
			$data = new stdClass();
			if(empty($order))
				continue;
			foreach($order as $k => $v) {
				if(in_array($k, $fields)) {
					$data->$k = $v;

					// Special support
					//
					if($k == 'order_shipping_method') {
						foreach($shippings as $shipping) {
							if($shipping->shipping_type == $order->order_shipping_method && $shipping->shipping_id == $order->order_shipping_id) {
								$data->$k = $shipping->shipping_name;
								break;
							}
						}
					}
					if($k == 'shipping_address_lastname') {
						$data->shipping_address_name = $order->shipping_address_firstname . ' ' . $order->shipping_address_lastname;
					}
				}
			}
			if(!empty($order->products)) {
				foreach($order->products as $product) {
					foreach($product as $k => $v) {
						$ik = 'item_'.$k;
						if(in_array($ik, $fields)) {
							$data->$ik = $v;
						}
						if(in_array($ik, $stripFields)) {
							$data->$ik = strip_tags($data->$ik);
						}
					}

					// Special support
					//
					$data->item_tax_code = 'S4';
					if(empty($data->item_order_product_tax) || bccomp($data->item_order_product_tax, 0, 5) == 0) {
						$data->item_tax_code = 'Z';
					}

					$newRows[] = (PHP_VERSION < 5) ? $data : clone($data);
				}
			} else {
				$newRows[] = $data;
			}
			unset($order);
			$rows[$k] = null;
		}
		$rows = $newRows;
	}
}